"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createAPI: () => createAPI,
  createCrud: () => createCrud,
  registerRoutes: () => registerRoutes
});
module.exports = __toCommonJS(src_exports);

// src/Controllers/registerRoutes.ts
var import_express = require("express");
var router = (0, import_express.Router)();
function registerRoutes(basePath, routes) {
  if (Array.isArray(routes)) {
    for (const route of routes) {
      Routed(basePath, route);
    }
  } else {
    Routed(basePath, routes);
  }
  return router;
}
function parsePath(path3) {
  return path3.replace(new RegExp("//", "g"), "/");
}
function middlewareParse(keys, middleware, func) {
  if (Array.isArray(func)) {
    if (middleware) {
      if (Array.isArray(middleware)) {
        return [...middleware, ...func];
      } else if (typeof middleware === "object") {
        if (middleware[keys]) {
          if (Array.isArray(middleware[keys])) {
            return [...[middleware[keys]], ...func];
          } else {
            return [middleware[keys], ...func];
          }
        }
      } else {
        return [middleware, ...func];
      }
    }
  } else {
    if (middleware) {
      if (Array.isArray(middleware)) {
        return [...middleware, func];
      } else if (typeof middleware === "object") {
        if (middleware[keys]) {
          if (Array.isArray(middleware[keys])) {
            return [...[middleware[keys]], func];
          } else {
            return [middleware[keys], func];
          }
        }
      } else {
        return [middleware, func];
      }
    }
  }
  return func;
}
function reorderObjectEntries(obj) {
  const keys = Object.keys(obj);
  const filteredKeys = keys.filter((key) => key.toLowerCase().startsWith("m"));
  const otherKeys = keys.filter((key) => !key.toLowerCase().startsWith("m"));
  const reorderedKeys = [...filteredKeys, ...otherKeys];
  return Object.entries(obj).sort(([keyA], [keyB]) => reorderedKeys.indexOf(keyA) - reorderedKeys.indexOf(keyB));
}
function Routed(basePath, route) {
  if (route.path.toLowerCase() === "index") {
    route.path = "";
    route.children = [];
  }
  const PATH = !basePath ? parsePath(`/${route.path}`) : parsePath(`/${basePath}/${route.path}`);
  const entries = reorderObjectEntries(route);
  let middleware = null;
  for (let [keys, functions] of entries) {
    switch (keys) {
      case "middleware":
        if (functions)
          middleware = functions;
        break;
      case "get":
      case "post":
      case "put":
      case "delete":
        if (Array.isArray(functions)) {
          functions = middlewareParse(keys, middleware, functions);
          router[keys](PATH, ...functions);
        } else {
          functions = middlewareParse(keys, middleware, functions);
          router[keys](PATH, functions);
        }
        break;
      case "children":
        registerRoutes(PATH, functions);
        break;
    }
  }
}

// src/Controllers/createCrud.ts
var import_path2 = __toESM(require("path"));

// src/Utils/functions.ts
var fs = __toESM(require("fs"));
var import_path = __toESM(require("path"));
function findFolder(directory, nameFolder) {
  let pathFound = null;
  function searchInDirectory(directorio) {
    const elements = fs.readdirSync(directorio);
    for (const element of elements) {
      const fullPath = import_path.default.join(directorio, element);
      const stats = fs.statSync(fullPath);
      if (stats.isDirectory()) {
        if (element === nameFolder) {
          pathFound = fullPath;
          break;
        } else {
          searchInDirectory(fullPath);
        }
      }
    }
  }
  searchInDirectory(directory);
  return pathFound;
}
function createIfNotExists(rutaCarpeta) {
  if (!fs.existsSync(rutaCarpeta))
    fs.mkdirSync(rutaCarpeta, { recursive: true });
}
function capitalizeFirstLetter(texto) {
  return texto.charAt(0).toUpperCase() + texto.substring(1);
}

// src/Controllers/createCrud.ts
var fs2 = __toESM(require("fs"));
function createCrud(table, service = false) {
  table = table.replace(/[^\w\s]/gi, "_");
  const className = capitalizeFirstLetter(table);
  const actualPath = import_path2.default.resolve();
  const folder = findFolder(actualPath, "API");
  if (!folder)
    throw "'API' folder not found";
  if (service)
    createService(folder, className);
  const instance = createController(folder, className, service);
  function routed(options) {
    const routing = {
      middleware: options?.middleware,
      path: table,
      children: []
    };
    const children = {
      middleware: options?.middleware,
      path: ":id"
    };
    const pages = {
      middleware: options?.middleware,
      path: "pages/:page",
      get: instance["pages"] ?? []
    };
    if (options) {
      const methods = options.methods;
      const isTrue = Object.values(methods).some((val) => val === true);
      const isFalse = Object.values(methods).some((val) => val === false);
      if (isTrue) {
        routing.get = typeof methods.get === "object" ? methods.get : methods.get === true ? instance["get"] : [];
        routing.post = typeof methods.post === "object" ? methods.post : methods.post === true ? instance["post"] : [];
        children.get = typeof methods.getOne === "object" ? methods.getOne : methods.getOne === true ? instance["getOne"] : [];
        children.put = typeof methods.put === "object" ? methods.put : methods.put === true ? instance["updateOne"] : [];
        children.delete = typeof methods.delete === "object" ? methods.delete : methods.delete === true ? instance["removeOne"] : [];
      } else if (isFalse) {
        routing.get = typeof methods.get === "object" ? methods.get : methods.get === false ? [] : instance["get"] ?? [];
        routing.post = typeof methods.post === "object" ? methods.post : methods.post === false ? [] : instance["post"] ?? [];
        children.get = typeof methods.getOne === "object" ? methods.getOne : methods.getOne === false ? [] : instance["getOne"] ?? [];
        children.put = typeof methods.put === "object" ? methods.put : methods.put === false ? [] : instance["updateOne"] ?? [];
        children.delete = typeof methods.delete === "object" ? methods.delete : methods.delete === false ? [] : instance["removeOne"] ?? [];
      } else {
        routing.get = typeof methods.get === "object" ? methods.get : instance["get"] ?? [];
        routing.post = typeof methods.post === "object" ? methods.post : instance["post"] ?? [];
        children.get = typeof methods.getOne === "object" ? methods.getOne : instance["getOne"] ?? [];
        children.put = typeof methods.put === "object" ? methods.put : instance["updateOne"] ?? [];
        children.delete = typeof methods.delete === "object" ? methods.delete : instance["removeOne"] ?? [];
      }
    }
    routing.children?.push(children);
    if (options?.pages)
      routing.children?.push(pages);
    if (options?.children) {
      const rout = routing.children ?? [];
      const newChildren = MiddlewareRecursive(options.children, options?.middleware);
      if (Array.isArray(newChildren)) {
        routing.children = [...rout, ...newChildren];
      } else if (newChildren) {
        routing.children?.push(newChildren);
      }
    }
    return registerRoutes(options?.basePath ?? "", routing);
  }
  return { routed };
}
var createController = (folder, className, service) => {
  let template;
  if (!fs2.existsSync(`${folder}/Controllers/${className}.controller.ts`)) {
    createIfNotExists(`${folder}/Controllers`);
    console.log("className", className);
    const baseTemplate = `${__dirname}/../dist/Template/Controllers`;
    if (className.toLowerCase() === "index") {
      template = `TEMPLATE_NAMEws_index.controller.ts`;
      if (service)
        template = `TEMPLATE_NAME_index.controller.ts`;
    } else {
      template = `TEMPLATE_NAME.controller.ts`;
      if (!service)
        template = `TEMPLATE_NAMEws.controller.ts`;
    }
    const ControllerOriginal = fs2.readFileSync(baseTemplate + "/" + template, "utf-8");
    const ControllerModif = ControllerOriginal.replace(new RegExp("TEMPLATE_NAME", "g"), className);
    fs2.writeFileSync(`${folder}/Controllers/${className}.controller.ts`, ControllerModif, "utf-8");
    console.log(`create ${className}`);
  }
  const instance = require(`${folder}/Controllers/${className}.controller.ts`);
  return instance;
};
var createService = (folder, serviceName) => {
  if (!fs2.existsSync(`${folder}/Services/${serviceName}.service.ts`)) {
    createIfNotExists(`${folder}/Services`);
    const ControllerOriginal = fs2.readFileSync(`${__dirname}/../dist/Template/Services/TEMPLATE_NAME.service.ts`, "utf-8");
    const ControllerModif = ControllerOriginal.replace(new RegExp("TEMPLATE_NAME", "g"), serviceName);
    fs2.writeFileSync(`${folder}/Services/${serviceName}.service.ts`, ControllerModif, "utf-8");
    console.log(`create service: ${serviceName}`);
  }
};
function MiddlewareRecursive(children, middleware) {
  if (Array.isArray(children)) {
    children.forEach((hijo) => {
      if (!hijo.middleware) {
        hijo.middleware = middleware;
      }
      MiddlewareRecursive(hijo, middleware);
    });
  } else {
    if (children) {
      if (!children.middleware) {
        children.middleware = middleware;
      }
      MiddlewareRecursive(children.children, middleware);
    }
  }
  return children;
}

// src/Controllers/createAPI.ts
function createAPI(basePath, params) {
  let route;
  if (Array.isArray(params)) {
    route = [];
    for (const param of params) {
      const routed = apiRoutering(basePath, param);
      route.push(routed);
    }
  } else {
    route = apiRoutering(basePath, params);
  }
  return route;
}
function apiRoutering(basePath, params) {
  let table = "index";
  let options = { methods: {} };
  options.middleware ??= params.middleware;
  options.pages ??= params.pages;
  options.basePath ??= basePath;
  options.methods.get ??= params.get;
  options.methods.getOne ??= params.getOne;
  options.methods.post ??= params.post;
  options.methods.put ??= params.put;
  options.methods.delete ??= params.delete;
  options.children ??= params.children;
  table = params.path && params.path !== "" ? params.path : table;
  return createCrud(table, params.service).routed(options);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createAPI,
  createCrud,
  registerRoutes
});
//! NECESITAMOS VALIDR SI EXISTE EN DIST O EXISTE EN TEST
